# maak/console.py
#
#

""" console bot. """


## =======
## IMPORTS
## =======

## maak imports

from maak import Bot, Event, dispatch, cmnds, tests

## oolib imports

from oolib.utils import error
from oolib.log import datefmt
from oolib import colors, cb

## basic imports

import logging
import time
import sys
import os

## ===========
## CONSOLE BOT
## ===========

## CONSOLE event

class CONSOLE(Event):

    def handle(self, *args , **kwargs):
        self.prepare()
        res = dispatch(cmnds, self, self.user_cmnd, *args, **kwargs)
        if not res: res = dispatch(tests, self, self.user_cmnd, *args, **kwargs)
        return self

## Console class

class ConsoleBot(Bot):

    def _raw(self, txt): sys.stdout.write(txt)

    def say(self, *args, **kwargs):
        try: txt = args[1]
        except IndexError: txt = args[0]
        self._raw(txt)
        self._raw("\n")
        
    def close(self): sys.stdout.flush()
        
    def get_one(self): return CONSOLE(txt=input("%s -=- %s%s<%s " % (time.strftime(datefmt), colors.BOLD, colors.YELLOW, colors.ENDC)))


def handle_CONSOLE(event): event.handle() ; event.show()

cb.register("CONSOLE", handle_CONSOLE)